import { Context } from 'koa';
import { InterfaceResponseData } from '../utils/response';
import { InterfaceDocument } from '../controllers/document';

export const putDocument = async (ctx: Context, params: InterfaceDocument) :Promise<InterfaceResponseData> => {
  return new Promise(resolve => {
    const reData: InterfaceResponseData = {
      data: null,
      message: '',
      success: false,
      code: 400000
    }
    ctx.$db.doc.findOne({ url: params.url }, (err, docs) => {
      if (err) {
        ctx.$log.error(err)
        ctx.status = 500
        return
      }
      if (docs) {
        reData.message = 'url已存在'
        resolve(reData)
        return
      }
      ctx.$db.doc.insert(params, (err, doc) => {
        if (err) {
          ctx.$log.error(err)
          ctx.status = 500
          return
        }
        reData.data = doc;
        reData.message = '保存成功'
        reData.success = true
        reData.code = 200
        resolve(reData)
      })
    })
  })
};

export default {
  putDocument
}
